%% Initialisation
clear all;
close all;
Fs = 44100;  % Frquence d'chantillonnage (Hz)
t = (0:2*Fs-1)/Fs;  % Gnration de la liste des temps (s)
Fm=800; % frquence du message (Hz)
Fp=8000; % Frquence de la porteuse (Hz)
%% Gnration du message  800 Hz
m = 4*sin(2*pi*Fm*t);  % Gnration du message
soundsc(m,Fs);  % Lecture du son
figure(1); plot(t,m); grid on;
%% Modulation du message avec modulation AM avec porteuse  8kHz
y = modulate(m,Fp,Fs,'am'); % Gnration du signal modul
soundsc(y,Fs); % Lecture du son
figure(2); plot(t,y,'b',t,m,'r'); grid on;
%% Ajout du bruit et dmodulation d'amplitude
yrecu = y + 3e-2*randn(size(m)); % Signal reu avec bruit
ydemod = demod(yrecu,Fp,Fs,'am'); % Dmodulation du signal reu signal
soundsc(ydemod,Fs); % Lecture du son
figure(3); plot(t,ydemod,'b',t,m,'r'); grid on; 
















%%
audiowrite('message.wav',m,Fs);
audiowrite('signalmodul.wav',y,Fs);
audiowrite('signaldemodul.wav',ydemod,Fs);

%%





















%% Affichage aprs modulation
temps=t(1*Fs:1.006*Fs);
mtrace=m(1*Fs:1.006*Fs);
ytrace=y(1*Fs:1.006*Fs);
figure(4);
plot(temps,ytrace,'b');
hold on;
plot(temps,mtrace,'r');
grid on;
legend('Signal modul','Message');
xlabel('Temps (s)');
ylabel('Amplitude')
axis([1 1.006 -5 5]);
%% Affichage aprs dmodulation
temps=t(1*Fs:1.006*Fs);
mtrace=m(1*Fs:1.006*Fs);
ydemodtrace=ydemod(1*Fs:1.006*Fs);
figure(5);
plot(temps,2*ydemodtrace,'b');
hold on;
plot(temps,mtrace,'r');
grid on;
legend('Signal dmodul','Message');
xlabel('Temps (s)');
ylabel('Amplitude')
axis([1 1.006 -5 5]);